﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;

namespace NicoLib {
	public class Nico:Basic {
		public bool isLogin { get; private set; }
//		protected string mail { get; private set; }
//		protected string password { get; private set; }

		/// <summary>
		/// 初期化
		/// </summary>
		public Nico() : base() {
			isLogin = false;
		}

		/// <summary>
		/// 初期化とログイン
		/// </summary>
		/// <param name="mail">メールアドレス</param>
		/// <param name="password">パスワード</param>
		public Nico(string mail , string password) : base() {
			Login(mail , password);
		}

	/*
			/// <summary>
			/// 初期化とcookieでログイン
			/// </summary>
			/// <param name="cc">CookieContainer</param>
			public Nico(CookieContainer cc) : base(cc){
				isLogin = true;
			}
	*/

		/// <summary>
		/// ログイン
		/// </summary>
		/// <param name="mail">メールアドレス</param>
		/// <param name="password">パスワード</param>
		/// <returns>成功したかどうか</returns>
		public bool Login(string mail , string password) {
			string reqLogin = HttpPost("https://secure.nicovideo.jp/secure/login?site=niconico","mail={0}&password={1}" , mail, password);
			if ( reqLogin != null && reqLogin.Contains("<a href=\"my/top\">マイページ</a>") ) {
				this.isLogin = true;
				return true;
			}
			this.isLogin = false;
			return false;
		}

	}
}
